"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/lib/form/style");

var _form = _interopRequireDefault(require("antd/lib/form"));

require("antd/lib/popconfirm/style");

var _popconfirm = _interopRequireDefault(require("antd/lib/popconfirm"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _ramda = require("ramda");

var _reactFinalForm = require("react-final-form");

var _finalFormArrays = _interopRequireDefault(require("final-form-arrays"));

var _reactFinalFormArrays = require("react-final-form-arrays");

var _classnames = _interopRequireDefault(require("classnames"));

var _styledComponents = require("styled-components");

var _FileUrlContext = _interopRequireDefault(require("../contexts/FileUrlContext"));

var _FormField = _interopRequireDefault(require("./FormField"));

var _Input = _interopRequireDefault(require("./editFields/Input"));

var _MceEditor = _interopRequireDefault(require("./editFields/MceEditor"));

var _Multiple = _interopRequireDefault(require("./editFields/Multiple"));

var _Switch = _interopRequireDefault(require("./editFields/Switch"));

var _withComponentsContext = _interopRequireDefault(require("../hocs/withComponentsContext"));

var _Uploader = _interopRequireDefault(require("./editFields/Uploader"));

var _RadioButtons = _interopRequireDefault(require("./editFields/RadioButtons"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n    .tox-notifications-container {\n        display: none;\n    }\n    .tox-tinymce-inline {\n        z-index: 1000;\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styles = {
  "editor": "editor__editor___1oMVM",
  "editorCol": "editor__editorCol___1rlEk",
  "editorPreviewCol": "editor__editorPreviewCol___3Lgw0",
  "editorField": "editor__editorField___1_Zq6",
  "editorModal": "editor__editorModal___2hd0A",
  "editorFooter": "editor__editorFooter___3Mszd",
  "editorFields": "editor__editorFields___csq02",
  "editorColHidePreview": "editor__editorColHidePreview___8DImo"
};
var formBuilderStyles = {
  "reactFormBuilder": "formBuilder__reactFormBuilder___o_kxH",
  "reactFormBuilderPreview": "formBuilder__reactFormBuilderPreview___23XDF",
  "reactFormBuilderPreviewBtn": "formBuilder__reactFormBuilderPreviewBtn___5zVZr",
  "droppableContainer": "formBuilder__droppableContainer___MUGU-",
  "reactFormBuilderPreviewModal": "formBuilder__reactFormBuilderPreviewModal___3MaJN",
  "experiumPlayerBuilder": "formBuilder__experiumPlayerBuilder___gMtxw"
};
var FIELDS = {
  editor: _MceEditor["default"],
  input: _Input["default"],
  multiple: _Multiple["default"],
  "switch": _Switch["default"],
  uploader: _Uploader["default"],
  radiobuttons: _RadioButtons["default"]
};
var GlobalStyle = (0, _styledComponents.createGlobalStyle)(_templateObject());

var EditElement = /*#__PURE__*/function (_Component) {
  _inherits(EditElement, _Component);

  var _super = _createSuper(EditElement);

  function EditElement() {
    var _this;

    _classCallCheck(this, EditElement);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "renderPreview", function (item) {
      var components = _this.props.components;
      var options = (0, _ramda.find)((0, _ramda.propEq)('type', item.type), components);
      var staticContent = options.staticContent,
          Component = options.formComponent;
      return staticContent ? /*#__PURE__*/_react["default"].createElement(_FileUrlContext["default"].Consumer, null, function (fileContext) {
        return /*#__PURE__*/_react["default"].createElement(Component, _extends({}, item, fileContext, {
          id: "preview"
        }));
      }) : /*#__PURE__*/_react["default"].createElement(_FormField["default"], {
        key: JSON.stringify(item),
        id: item.allowCorrect ? 'correct' : 'preview',
        isField: !!item.allowCorrect,
        item: item,
        options: options,
        fieldType: item.type,
        component: Component,
        preview: true,
        view: false
      });
    });

    return _this;
  }

  _createClass(EditElement, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          item = _this$props.item,
          placeholder = _this$props.placeholder,
          onSubmit = _this$props.onSubmit,
          components = _this$props.components,
          onCancel = _this$props.onCancel;

      var _find = (0, _ramda.find)((0, _ramda.propEq)('type', item.type), components),
          _find$fields = _find.fields,
          fields = _find$fields === void 0 ? [] : _find$fields,
          hidePreview = _find.hidePreview;

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(formBuilderStyles.experiumPlayerBuilder, 'experium-player-builder')
      }, /*#__PURE__*/_react["default"].createElement(GlobalStyle, null), /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Form, {
        onSubmit: onSubmit,
        initialValues: item,
        mutators: _finalFormArrays["default"],
        render: function render(_ref) {
          var handleSubmit = _ref.handleSubmit,
              values = _ref.values;
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.editor, item.type, 'edit-element')
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.editorCol, 'edit-element-col', _defineProperty({}, styles.editorColHidePreview, hidePreview))
          }, /*#__PURE__*/_react["default"].createElement(_form["default"], {
            onFinish: handleSubmit
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.editorFields, 'edit-element-fields')
          }, fields.map(function (item) {
            return ((0, _ramda.path)(['props', 'cond'], item) ? item.props.cond(values) : true) && FIELDS[item.type] ? item.fieldArray ? /*#__PURE__*/_react["default"].createElement(_reactFinalFormArrays.FieldArray, _extends({
              key: "field-".concat(item.prop),
              name: item.prop,
              component: FIELDS[item.type],
              label: item.label,
              description: item.description,
              variantPlaceholder: placeholder
            }, item.props || {})) : /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Field, _extends({
              key: "field-".concat(item.prop),
              name: item.prop,
              component: FIELDS[item.type],
              label: item.label,
              placeholder: placeholder
            }, item.props || {}, {
              hidePreview: hidePreview
            })) : null;
          })), /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.editorFooter, 'edit-element-footer')
          }, /*#__PURE__*/_react["default"].createElement(_button["default"].Group, null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
            type: "primary",
            htmlType: "submit"
          }, "\u0421\u043E\u0445\u0440\u0430\u043D\u0438\u0442\u044C"), /*#__PURE__*/_react["default"].createElement(_popconfirm["default"], {
            title: "\u0412\u044B \u0443\u0432\u0435\u0440\u0435\u043D\u044B, \u0447\u0442\u043E \u0445\u043E\u0442\u0438\u0442\u0435 \u043E\u0442\u043C\u0435\u043D\u0438\u0442\u044C \u0432\u0441\u0435 \u0438\u0437\u043C\u0435\u043D\u0435\u043D\u0438\u044F?",
            okText: "\u0414\u0430",
            cancelText: "\u041D\u0435\u0442",
            onConfirm: onCancel
          }, /*#__PURE__*/_react["default"].createElement(_button["default"], null, "\u041E\u0442\u043C\u0435\u043D\u0430")))))), !hidePreview && /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.editorPreviewCol, 'edit-element-preview-col experium-player-elements')
          }, _this2.renderPreview(values)));
        }
      }));
    }
  }]);

  return EditElement;
}(_react.Component);

var _default = (0, _withComponentsContext["default"])(EditElement);

exports["default"] = _default;