"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/lib/form/style");

var _form = _interopRequireDefault(require("antd/lib/form"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactFinalForm = require("react-final-form");

var _ramda = require("ramda");

var _withFileUrlContext = _interopRequireDefault(require("../hocs/withFileUrlContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var required = function required(value) {
  return !value ? 'Обязательно для заполнения' : undefined;
};

var incorrect = function incorrect(value, correct) {
  return value !== correct ? 'Неправильный ответ' : undefined;
};

var FormField = /*#__PURE__*/function (_Component) {
  _inherits(FormField, _Component);

  var _super = _createSuper(FormField);

  function FormField() {
    var _this;

    _classCallCheck(this, FormField);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "renderField", function () {
      var _this$props = _this.props,
          id = _this$props.id,
          Component = _this$props.component,
          item = _this$props.item,
          options = _this$props.options,
          fieldType = _this$props.fieldType,
          value = _this$props.value,
          view = _this$props.view,
          noCheckCorrect = _this$props.noCheckCorrect,
          downloadUrl = _this$props.downloadUrl;
      var disabled = !(0, _ramda.isNil)(value) || view;
      return /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Field, _extends({
        name: id,
        component: Component,
        validate: function validate(value) {
          return disabled ? undefined : item.required && required(value) || !noCheckCorrect && item.allowCorrect && (options.correctValidator ? options.correctValidator(value, item.correct, item) : incorrect(value, item.correct)) || undefined;
        },
        fieldType: fieldType,
        id: id,
        disabled: disabled,
        downloadUrl: downloadUrl
      }, item, {
        allowCorrect: !noCheckCorrect && item.allowCorrect
      }));
    });

    return _this;
  }

  _createClass(FormField, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var isField = this.props.isField;
      return isField ? this.renderField() : /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Form, {
        className: "form-generator",
        onSubmit: function onSubmit() {},
        subscription: {
          submitting: true,
          submitFailed: true,
          error: true
        },
        render: function render(_ref) {
          var handleSubmit = _ref.handleSubmit;
          return /*#__PURE__*/_react["default"].createElement(_form["default"], {
            onFinish: handleSubmit
          }, _this2.renderField());
        }
      });
    }
  }]);

  return FormField;
}(_react.Component);

_defineProperty(FormField, "propTypes", {
  item: _propTypes["default"].object,
  options: _propTypes["default"].object,
  component: _propTypes["default"].func,
  value: _propTypes["default"].any,
  id: _propTypes["default"].string,
  fieldType: _propTypes["default"].string,
  preview: _propTypes["default"].bool,
  view: _propTypes["default"].bool
});

var _default = (0, _withFileUrlContext["default"])(FormField);

exports["default"] = _default;