"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormGenerator = void 0;

require("antd/lib/form/style");

var _form = _interopRequireDefault(require("antd/lib/form"));

require("antd/lib/row/style");

var _row = _interopRequireDefault(require("antd/lib/row"));

require("antd/lib/col/style");

var _col = _interopRequireDefault(require("antd/lib/col"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ramda = require("ramda");

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _reactFinalForm = require("react-final-form");

var _componentsDefaults = _interopRequireDefault(require("../constants/componentsDefaults"));

var _FormField = _interopRequireDefault(require("./FormField"));

var _FileUrlContext = _interopRequireDefault(require("../contexts/FileUrlContext"));

var _ComponentsContext = _interopRequireDefault(require("../contexts/ComponentsContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "reactFormBuilder": "formBuilder__reactFormBuilder___o_kxH",
  "reactFormBuilderPreview": "formBuilder__reactFormBuilderPreview___23XDF",
  "reactFormBuilderPreviewBtn": "formBuilder__reactFormBuilderPreviewBtn___5zVZr",
  "droppableContainer": "formBuilder__droppableContainer___MUGU-",
  "reactFormBuilderPreviewModal": "formBuilder__reactFormBuilderPreviewModal___3MaJN",
  "experiumPlayerBuilder": "formBuilder__experiumPlayerBuilder___gMtxw"
};

var FormGenerator = /*#__PURE__*/function (_Component) {
  _inherits(FormGenerator, _Component);

  var _super = _createSuper(FormGenerator);

  function FormGenerator() {
    var _this;

    _classCallCheck(this, FormGenerator);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      page: 0
    });

    _defineProperty(_assertThisInitialized(_this), "onSubmit", function (values) {
      _this.props.onSubmit && _this.props.onSubmit(values);
    });

    _defineProperty(_assertThisInitialized(_this), "getComponents", function (placeholder) {
      return (0, _ramda.concat)((0, _componentsDefaults["default"])(placeholder), _this.props.components);
    });

    _defineProperty(_assertThisInitialized(_this), "goBack", function () {
      return _this.setState(function (prev) {
        return {
          page: prev.page - 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "goNext", function (formProps, values) {
      _this.setState(function (prev) {
        return {
          page: prev.page + 1
        };
      });

      formProps.reset(values);
    });

    _defineProperty(_assertThisInitialized(_this), "renderFooter", function (footerProps) {
      var renderFooter = footerProps.renderFooter,
          staticContent = footerProps.staticContent,
          index = footerProps.index,
          invalid = footerProps.invalid,
          formProps = footerProps.formProps,
          formValues = footerProps.formValues,
          handleSubmit = footerProps.handleSubmit;
      var _this$props = _this.props,
          _this$props$data = _this$props.data,
          _this$props$data$comm = _this$props$data.common,
          common = _this$props$data$comm === void 0 ? {} : _this$props$data$comm,
          items = _this$props$data.items,
          elements = _this$props$data.elements,
          submitText = _this$props.submitText,
          onHandleSubmit = _this$props.onHandleSubmit;
      var page = _this.state.page;
      var components = (0, _componentsDefaults["default"])().concat(_this.props.components);
      var showSubmit = (0, _ramda.any)(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            _ = _ref2[0],
            item = _ref2[1];

        return !(0, _ramda.path)(['staticContent'], (0, _ramda.find)((0, _ramda.propEq)('type', item.type), components));
      }, (0, _ramda.toPairs)(elements));
      return renderFooter ? renderFooter(_objectSpread(_objectSpread({}, footerProps), {}, {
        showSubmit: showSubmit,
        page: page,
        goNext: function goNext() {
          return _this.goNext(formProps, formValues);
        }
      }), _this.props) : /*#__PURE__*/_react["default"].createElement(_button["default"].Group, {
        className: "experium-player-footer"
      }, common.pages && page > 0 && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        htmlType: "submit",
        onClick: _this.goBack
      }, "\u041D\u0430\u0437\u0430\u0434"), showSubmit && (!staticContent && common.everyQuestionSubmit || (common.pages ? page : index) === items.length - 1) && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        type: "primary",
        onClick: function onClick() {
          if (onHandleSubmit) {
            onHandleSubmit(footerProps, _this.props);
          }

          handleSubmit();
        }
      }, submitText || 'Сохранить'), common.pages && page < items.length - 1 && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        htmlType: "submit",
        onClick: !invalid ? function () {
          return _this.goNext(formProps, formValues);
        } : null
      }, "\u0412\u043F\u0435\u0440\u0435\u0434"));
    });

    _defineProperty(_assertThisInitialized(_this), "renderRow", function (id, index, invalid, formProps, formValues, errors, submitFailed, handleSubmit) {
      var _this$props2 = _this.props,
          _this$props2$data$ele = _this$props2.data.elements,
          elements = _this$props2$data$ele === void 0 ? {} : _this$props2$data$ele,
          preview = _this$props2.preview,
          values = _this$props2.values,
          view = _this$props2.view,
          disable = _this$props2.disable,
          noCheckCorrect = _this$props2.noCheckCorrect,
          placeholder = _this$props2.placeholder,
          renderFooter = _this$props2.renderFooter;
      var item = (0, _ramda.pathOr)({}, [id], elements);
      var options = (0, _ramda.find)((0, _ramda.propEq)('type', item.type), _this.getComponents(placeholder));

      if (!options) {
        return null;
      }

      var staticContent = options.staticContent,
          fieldType = options.fieldType,
          Component = options.formComponent;
      return /*#__PURE__*/_react["default"].createElement(_row["default"], {
        key: "row-".concat(id)
      }, /*#__PURE__*/_react["default"].createElement(_col["default"], {
        span: 24
      }, staticContent ? /*#__PURE__*/_react["default"].createElement(_FileUrlContext["default"].Consumer, null, function (fileContext) {
        return /*#__PURE__*/_react["default"].createElement(Component, _extends({}, item, fileContext, {
          id: id
        }));
      }) : /*#__PURE__*/_react["default"].createElement(_FormField["default"], {
        id: id,
        item: item,
        options: options,
        fieldType: fieldType,
        component: Component,
        view: view,
        preview: preview,
        value: disable ? (0, _ramda.path)([id], values) : undefined,
        noCheckCorrect: noCheckCorrect,
        isField: true
      })), _this.renderFooter({
        renderFooter: renderFooter,
        staticContent: staticContent,
        index: index,
        invalid: invalid,
        formProps: formProps,
        formValues: formValues,
        errors: errors,
        submitFailed: submitFailed,
        handleSubmit: handleSubmit
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "hasFields", function () {
      var _this$props$data$elem = _this.props.data.elements,
          elements = _this$props$data$elem === void 0 ? {} : _this$props$data$elem;
      return (0, _ramda.any)(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            item = _ref4[1];

        return !(0, _ramda.find)((0, _ramda.propEq)('type', item.type), _this.getComponents(placeholder)).staticContent;
      }, (0, _ramda.toPairs)(elements));
    });

    return _this;
  }

  _createClass(FormGenerator, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          _this$props3$data = _this$props3.data,
          _this$props3$data$ite = _this$props3$data.items,
          items = _this$props3$data$ite === void 0 ? [] : _this$props3$data$ite,
          _this$props3$data$com = _this$props3$data.common,
          common = _this$props3$data$com === void 0 ? {} : _this$props3$data$com,
          uploadUrl = _this$props3.uploadUrl,
          downloadUrl = _this$props3.downloadUrl,
          uploadImages = _this$props3.uploadImages,
          values = _this$props3.values;
      var page = this.state.page;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.experiumPlayerBuilder, 'experium-player-builder', 'experium-player-elements'),
        style: {
          background: common.pageColor || 'transparent',
          padding: 15
        }
      }, /*#__PURE__*/_react["default"].createElement(_ComponentsContext["default"].Provider, {
        value: this.getComponents()
      }, /*#__PURE__*/_react["default"].createElement(_FileUrlContext["default"].Provider, {
        value: {
          uploadUrl: uploadUrl,
          downloadUrl: downloadUrl,
          uploadImages: uploadImages
        }
      }, /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Form, {
        className: "formGenerator",
        onSubmit: this.onSubmit,
        initialValues: values,
        subscription: {
          submitting: true,
          submitFailed: true,
          invalid: true,
          errors: true,
          values: true
        },
        render: function render(_ref5) {
          var handleSubmit = _ref5.handleSubmit,
              invalid = _ref5.invalid,
              values = _ref5.values,
              form = _ref5.form,
              errors = _ref5.errors,
              submitFailed = _ref5.submitFailed;
          return /*#__PURE__*/_react["default"].createElement(_form["default"], {
            onFinish: handleSubmit
          }, /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.DragDropContext, null, (0, _ramda.addIndex)(_ramda.filter)(function (item, index) {
            return common.pages ? index === page : true;
          }, items).map(function (row, index) {
            return _this2.renderRow(row, index, invalid, form, values, errors, submitFailed, handleSubmit);
          })));
        }
      }))));
    }
  }]);

  return FormGenerator;
}(_react.Component);

exports.FormGenerator = FormGenerator;

_defineProperty(FormGenerator, "propTypes", {
  data: _propTypes["default"].object,
  onSubmit: _propTypes["default"].func,
  renderFooter: _propTypes["default"].func,
  preview: _propTypes["default"].bool,
  values: _propTypes["default"].object,
  components: _propTypes["default"].array,
  view: _propTypes["default"].bool
});

_defineProperty(FormGenerator, "defaultProps", {
  data: {},
  values: {},
  disable: true,
  components: []
});