"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/lib/upload/style");

var _upload = _interopRequireDefault(require("antd/lib/upload"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _icons = require("@ant-design/icons");

var _withFileUrlContext = _interopRequireDefault(require("../../hocs/withFileUrlContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "image": "imageUploader__image___3Ty7X",
  "imageInfo": "imageUploader__imageInfo___23LyR",
  "imageRemoveBtn": "imageUploader__imageRemoveBtn___29f5L"
};

var ImageUploader = /*#__PURE__*/function (_Component) {
  _inherits(ImageUploader, _Component);

  var _super = _createSuper(ImageUploader);

  function ImageUploader() {
    var _this;

    _classCallCheck(this, ImageUploader);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      error: false
    });

    _defineProperty(_assertThisInitialized(_this), "reader", new FileReader());

    _defineProperty(_assertThisInitialized(_this), "beforeUpload", function (file) {
      _this.reader.readAsDataURL(file);

      _this.reader.onload = function () {
        return _this.props.input.onChange({
          name: file.name,
          data: _this.reader.result
        });
      };

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (info) {
      var _info$file = info.file,
          status = _info$file.status,
          response = _info$file.response,
          name = _info$file.name;

      switch (status) {
        case 'done':
          _this.setState({
            error: false
          });

          _this.props.input.onChange({
            name: name,
            id: response.id
          });

          break;

        case 'error':
          _this.setState({
            error: true
          });

          break;

        default:
          return;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "remove", function () {
      return _this.props.input.onChange(null);
    });

    _defineProperty(_assertThisInitialized(_this), "renderStaticUploader", function () {
      return /*#__PURE__*/_react["default"].createElement(_upload["default"], {
        accept: "image/*",
        beforeUpload: _this.beforeUpload,
        fileList: []
      }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        icon: /*#__PURE__*/_react["default"].createElement(_icons.FileImageOutlined, null)
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "renderRequestUploader", function () {
      return /*#__PURE__*/_react["default"].createElement(_upload["default"], {
        showUploadList: false,
        accept: "image/*",
        action: _this.props.uploadUrl,
        onChange: _this.onChange
      }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        style: {
          color: _this.state.error ? 'red' : ''
        },
        icon: /*#__PURE__*/_react["default"].createElement(_icons.FileImageOutlined, null)
      }));
    });

    return _this;
  }

  _createClass(ImageUploader, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          uploadImages = _this$props.uploadImages,
          downloadUrl = _this$props.downloadUrl;
      var value = this.props.input.value;
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, uploadImages ? this.renderRequestUploader() : this.renderStaticUploader(), value && /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.imageInfo, 'image-uploader-info')
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.image, 'image-uploader-img'),
        style: {
          backgroundImage: "url('".concat(value.id ? downloadUrl(value.id) : value.data, "')")
        }
      }), value.name, /*#__PURE__*/_react["default"].createElement(_icons.CloseOutlined, {
        className: (0, _classnames["default"])(styles.imageRemoveBtn, 'image-uploader-remove-btn'),
        onClick: this.remove
      })));
    }
  }]);

  return ImageUploader;
}(_react.Component);

var _default = (0, _withFileUrlContext["default"])(ImageUploader);

exports["default"] = _default;