"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _tinymceReact = require("@tinymce/tinymce-react");

var _classnames = _interopRequireDefault(require("classnames"));

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

var _MceLanguageUrl = _interopRequireDefault(require("../../contexts/MceLanguageUrl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var styles = {
  "editorInput": "editorInput__editorInput___1WcYS",
  "editorInputShort": "editorInput__editorInputShort___3k_dC"
};

var MceEditor = /*#__PURE__*/function (_Component) {
  _inherits(MceEditor, _Component);

  var _super = _createSuper(MceEditor);

  function MceEditor() {
    _classCallCheck(this, MceEditor);

    return _super.apply(this, arguments);
  }

  _createClass(MceEditor, [{
    key: "render",
    value: function render() {
      var _cx;

      var _this$props = this.props,
          value = _this$props.input.value,
          onChange = _this$props.onChange,
          _short = _this$props["short"],
          hidePreview = _this$props.hidePreview;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])((_cx = {}, _defineProperty(_cx, styles.editorInputShort, _short), _defineProperty(_cx, styles.editorInput, !hidePreview), _cx))
      }, /*#__PURE__*/_react["default"].createElement(_MceLanguageUrl["default"].Consumer, null, function (languageUrl) {
        return /*#__PURE__*/_react["default"].createElement(_tinymceReact.Editor, {
          value: value,
          onEditorChange: onChange,
          inline: !hidePreview,
          init: {
            plugins: 'autoresize image lists link table code paste',
            min_height: 350,
            menubar: !_short,
            language: 'ru',
            branding: false,
            paste_as_text: true,
            fontsize_formats: '8px 10px 12px 14px 18px 24px 36px',
            content_style: hidePreview ? "\n                                ol, li, ul, span { color: rgba(0, 0, 0, 0.65); font-size: 14px; font-family: 'Roboto', sans-serif; }\n                                div { color: rgba(0, 0, 0, 0.65); color: rgba(0, 0, 0, 0.65); }\n                                h1 { font-size: 28px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h1 span { font-size: 28px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h2 { font-size: 21px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h2 span { font-size: 21px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h3 { font-size: 16.38px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h3 span { font-size: 16.38px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h4 { font-size: 14px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h4 span { font-size: 14px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h5 { font-size: 11.62px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h5 span { font-size: 11.62px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h6 { font-size: 9.38px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                h6 span { font-size: 9.38px; color: rgba(0, 0, 0, 0.85); font-family: 'Roboto', sans-serif; }\n                                p { margin-top: 0; margin-bottom: 1em; color: rgba(0, 0, 0, 0.65); font-size: 14px; font-family: 'Roboto', sans-serif; }\n                            " : null,
            content_css: ['https://fonts.googleapis.com/css?family=Roboto:400,700&display=swap&subset=cyrillic'],
            language_url: languageUrl || '/translations/ru.js',
            toolbar_drawer: 'sliding',
            font_formats: 'Andale Mono=andale mono,monospace;' + 'Arial=arial,helvetica,sans-serif;' + 'Arial Black=arial black,sans-serif;' + 'Book Antiqua=book antiqua,palatino,serif;' + 'Comic Sans MS=comic sans ms,sans-serif;' + 'Courier New=courier new,courier,monospace;' + 'Georgia=georgia,palatino,serif;' + 'Helvetica=helvetica,arial,sans-serif;' + 'Impact=impact,sans-serif;' + 'Roboto=Roboto,sans-serif;' + 'Symbol=symbol;' + 'Tahoma=tahoma,arial,helvetica,sans-serif;' + 'Terminal=terminal,monaco,monospace;' + 'Times New Roman=times new roman,times,serif;' + 'Trebuchet MS=trebuchet ms,geneva,sans-serif;' + 'Verdana=verdana,geneva,sans-serif;' + 'Webdings=webdings;' + 'Wingdings=wingdings,zapf dingbats',
            toolbar: _short ? 'undo redo | bold italic underline | forecolor backcolor | link | removeformat' : 'formatselect | fontselect | fontsizeselect | bold italic strikethrough underline forecolor backcolor | alignleft aligncenter alignright alignjustify | removeformat | bullist numlist outdent indent | link image | code',
            images_upload_handler: function images_upload_handler(info, success) {
              var fr = new FileReader();
              fr.readAsDataURL(info.blob());

              fr.onload = function () {
                return success(fr.result);
              };
            },
            setup: function setup(editor) {
              editor.on('init', function (ed) {
                ed.target.editorCommands.execCommand('fontName', false, 'Roboto');
              });
              editor.on('BeforeSetContent', function (e) {
                if (e.content.startsWith('<table ')) {
                  e.content = "<div class=\"table-wrap\">".concat(e.content, "</div>");
                }
              });
            }
          }
        });
      }));
    }
  }]);

  return MceEditor;
}(_react.Component);

var _default = (0, _withFieldWrapper["default"])(MceEditor);

exports["default"] = _default;