"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _draftJs = require("draft-js");

var _draftJsExportHtml = require("draft-js-export-html");

var _draftJsImportHtml = require("draft-js-import-html");

var _ramda = require("ramda");

var _classnames = _interopRequireDefault(require("classnames"));

var _InlineToolbar = _interopRequireDefault(require("./InlineToolbar"));

var _editor = require("../../utils/editor");

var _Link = _interopRequireDefault(require("./Link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "toolbar": "editorToolbar__toolbar___r4vlg",
  "showToolbar": "editorToolbar__showToolbar___2Ygda",
  "toolbarItems": "editorToolbar__toolbarItems___2zvDc",
  "toolbarItem": "editorToolbar__toolbarItem___1D-K3",
  "toolbarItemsArrow": "editorToolbar__toolbarItemsArrow___2PwFu",
  "active": "editorToolbar__active___24dHq",
  "bold": "editorToolbar__bold___1I-VY",
  "italic": "editorToolbar__italic___1cQ9v",
  "underline": "editorToolbar__underline___xoLQR",
  "toolbarLinkContainer": "editorToolbar__toolbarLinkContainer___14xpk"
};
var ALIGNMENTS = ['left', 'right', 'center'];

var EditorComponent = /*#__PURE__*/function (_Component) {
  _inherits(EditorComponent, _Component);

  var _super = _createSuper(EditorComponent);

  function EditorComponent(props) {
    var _this;

    _classCallCheck(this, EditorComponent);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "onChange", function (editorState) {
      var html = (0, _draftJsExportHtml.stateToHTML)(editorState.getCurrentContent(), {
        inlineStyleFn: function inlineStyleFn(styles) {
          var textAlign = styles.filter(function (value) {
            return (0, _ramda.contains)(value, ['center', 'left', 'right']);
          }).first();
          return textAlign ? {
            element: 'p',
            style: {
              textAlign: textAlign
            }
          } : null;
        }
      });

      _this.setState({
        editorState: editorState
      }, function () {
        if (!editorState.getSelection().isCollapsed()) {
          var selectionRange = (0, _editor.getSelectionRange)();

          if (!selectionRange) {
            !_this.state.linkToolbar && _this.setState({
              showToolbar: false
            });
            return;
          }

          _this.setState({
            showToolbar: true,
            selectionRange: selectionRange
          });
        } else {
          _this.setState({
            showToolbar: false,
            linkToolbar: false
          });
        }
      });

      _this.props.onChange(_this.props.path, html);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyCommand", function (command, editorState) {
      var newState = _draftJs.RichUtils.handleKeyCommand(editorState, command);

      if (newState) {
        _this.onChange(newState);

        return 'handled';
      }

      return 'not-handled';
    });

    _defineProperty(_assertThisInitialized(_this), "toggleInlineStyle", function (style, inline) {
      var _this$state = _this.state,
          editorState = _this$state.editorState,
          urlValue = _this$state.urlValue;
      var newState = style === 'link' ? inline ? (0, _editor.confirmLink)(editorState, urlValue) : (0, _editor.removeLink)(editorState) : (0, _ramda.contains)(style, ALIGNMENTS) ? (0, _editor.styleWholeSelectedBlocksModifier)(editorState, style, (0, _ramda.without)([style], ALIGNMENTS)) : inline ? _draftJs.RichUtils.toggleInlineStyle(editorState, style) : _draftJs.RichUtils.toggleBlockType(editorState, style);

      _this.onChange(newState);
    });

    _defineProperty(_assertThisInitialized(_this), "blockStyleFn", function (block) {
      var alignment = (0, _editor.getBlockAlignment)(block);

      if (!block.getText()) {
        var previousBlock = _this.state.editorState.getCurrentContent().getBlockBefore(block.getKey());

        if (previousBlock) {
          alignment = (0, _editor.getBlockAlignment)(previousBlock);
        }
      }

      return "alignment--".concat(alignment);
    });

    _defineProperty(_assertThisInitialized(_this), "toggleLinkToolbar", function (linkToolbar) {
      return _this.setState({
        linkToolbar: linkToolbar,
        showToolbar: linkToolbar
      });
    });

    var _value = (0, _ramda.path)(props.path.split('.').map(function (i) {
      return (0, _ramda.identical)(NaN, +i) ? i : +i;
    }), props);

    _this.state = {
      showToolbar: false,
      linkToolbar: false,
      selectionRange: null,
      editorState: !props.isEditor ? null : _value ? _draftJs.EditorState.createWithContent((0, _draftJsImportHtml.stateFromHTML)(_value)) : _draftJs.EditorState.createEmpty()
    };
    return _this;
  }

  _createClass(EditorComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.isEditor && this.onChange(_draftJs.EditorState.set(this.state.editorState, {
        decorator: new _draftJs.CompositeDecorator([{
          strategy: function strategy(contentBlock, callback, contentState) {
            return (0, _editor.findEntities)('LINK', contentBlock, callback, contentState);
          },
          component: _Link["default"]
        }])
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          isEditor = _this$props.isEditor,
          path = _this$props.path,
          _short = _this$props["short"],
          staticContent = _this$props.staticContent;
      var _this$state2 = this.state,
          editorState = _this$state2.editorState,
          showToolbar = _this$state2.showToolbar,
          selectionRange = _this$state2.selectionRange,
          linkToolbar = _this$state2.linkToolbar;
      return isEditor ? /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(node) {
          return _this2.container = node;
        },
        className: (0, _classnames["default"])(styles.editorContainer, 'editor-container', _defineProperty({}, styles.block, staticContent))
      }, /*#__PURE__*/_react["default"].createElement(_InlineToolbar["default"], {
        editorState: editorState,
        onToggle: this.toggleInlineStyle,
        onChange: this.onChange,
        selectionRange: selectionRange,
        show: showToolbar,
        linkToolbar: linkToolbar,
        toggleLinkToolbar: this.toggleLinkToolbar,
        "short": _short
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.editorWrapper, 'editor-wrapper'),
        onClick: function onClick() {
          return _this2.editor.focus();
        }
      }, /*#__PURE__*/_react["default"].createElement(_draftJs.Editor, {
        ref: function ref(node) {
          return _this2.editor = node;
        },
        editorState: this.state.editorState,
        onChange: this.onChange,
        placeholder: "\u0412\u0432\u0435\u0434\u0438\u0442\u0435 \u0432\u0430\u0448 \u0442\u0435\u043A\u0441\u0442...",
        handleKeyCommand: this.handleKeyCommand,
        blockStyleFn: this.blockStyleFn
      }))) : /*#__PURE__*/_react["default"].createElement("div", {
        dangerouslySetInnerHTML: {
          __html: this.props[path]
        }
      });
    }
  }]);

  return EditorComponent;
}(_react.Component);

exports["default"] = EditorComponent;

_defineProperty(EditorComponent, "defaultProps", {
  isEditor: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  "short": _propTypes["default"].bool
});

_defineProperty(EditorComponent, "defaultProps", {
  path: 'content'
});