"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FileField = exports["default"] = void 0;

require("antd/lib/upload/style");

var _upload = _interopRequireDefault(require("antd/lib/upload"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _icons = require("@ant-design/icons");

var _withElementWrapper = require("../../hocs/withElementWrapper");

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

var _withFileUrlContext = _interopRequireDefault(require("../../hocs/withFileUrlContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var File = /*#__PURE__*/function (_Component) {
  _inherits(File, _Component);

  var _super = _createSuper(File);

  function File() {
    var _this;

    _classCallCheck(this, File);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      error: false
    });

    _defineProperty(_assertThisInitialized(_this), "reader", new FileReader());

    _defineProperty(_assertThisInitialized(_this), "beforeUpload", function (file) {
      _this.reader.readAsDataURL(file);

      _this.reader.onload = function () {
        return _this.props.onChange(_this.reader.result);
      };

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (info) {
      switch (info.file.status) {
        case 'done':
          _this.props.onChange(info.file.response.id);

          _this.state.error && _this.setState({
            error: false
          });
          break;

        case 'error':
          _this.setState({
            error: true
          });

          break;

        default:
          break;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "delete", function () {
      return _this.props.onChange(null);
    });

    return _this;
  }

  _createClass(File, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          value = _this$props.input.value,
          uploadUrl = _this$props.uploadUrl,
          downloadUrl = _this$props.downloadUrl;
      var props = uploadUrl ? {
        action: uploadUrl,
        onChange: this.onChange
      } : {
        beforeUpload: this.beforeUpload
      };
      return value ? /*#__PURE__*/_react["default"].createElement(_button["default"].Group, null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        download: true,
        href: downloadUrl ? downloadUrl(value) : value,
        target: "_blank"
      }, /*#__PURE__*/_react["default"].createElement(_icons.DownloadOutlined, null), " \u0421\u043A\u0430\u0447\u0430\u0442\u044C"), /*#__PURE__*/_react["default"].createElement(_button["default"], {
        danger: true,
        onClick: this["delete"]
      }, /*#__PURE__*/_react["default"].createElement(_icons.DeleteOutlined, null), " \u0423\u0434\u0430\u043B\u0438\u0442\u044C")) : /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_upload["default"], _extends({}, props, {
        fileList: []
      }), /*#__PURE__*/_react["default"].createElement(_button["default"], null, /*#__PURE__*/_react["default"].createElement(_icons.UploadOutlined, null), " \u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044C \u0444\u0430\u0439\u043B")), this.state.error && /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          color: 'red'
        }
      }, "\u041D\u0435 \u0443\u0434\u0430\u043B\u043E\u0441\u044C \u0437\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044C \u0444\u0430\u0439\u043B"));
    }
  }]);

  return File;
}(_react.Component);

var _default = (0, _withElementWrapper.withElementWrapper)((0, _withFileUrlContext["default"])(File));

exports["default"] = _default;
var FileField = (0, _withFieldWrapper["default"])((0, _withFileUrlContext["default"])(File));
exports.FileField = FileField;