"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ImageComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ramda = require("ramda");

var _classnames = _interopRequireDefault(require("classnames"));

var _withElementWrapper = require("../../hocs/withElementWrapper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ImageComponent = /*#__PURE__*/function (_Component) {
  _inherits(ImageComponent, _Component);

  var _super = _createSuper(ImageComponent);

  function ImageComponent() {
    var _this;

    _classCallCheck(this, ImageComponent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      height: 0,
      coverHeight: 0
    });

    _defineProperty(_assertThisInitialized(_this), "getHeight", function () {
      var downloadUrl = _this.props.downloadUrl;
      var url = (0, _ramda.pathOr)({}, ['url'], _this.props);

      if (url) {
        var img = new Image();
        img.src = url.id ? downloadUrl(url.id) : url.body;

        img.onload = function () {
          var height = _this.container.clientWidth < img.width ? _this.container.clientWidth * 100 / img.width * img.height / 100 : img.height;

          _this.setState({
            height: height,
            coverHeight: _this.container.clientWidth > img.width ? _this.container.clientWidth * 100 / img.width * img.height / 100 : height
          });
        };
      } else {
        _this.setState({
          height: 0,
          coverHeight: 0
        });
      }
    });

    return _this;
  }

  _createClass(ImageComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getHeight();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prev) {
      if ((0, _ramda.path)(['url', 'name'], prev) !== (0, _ramda.path)(['url', 'name'], this.props)) {
        this.getHeight();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          cover = _this$props.cover,
          repeat = _this$props.repeat,
          downloadUrl = _this$props.downloadUrl;
      var url = (0, _ramda.pathOr)({}, ['url'], this.props);
      return url ? /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('imageContainer', {
          imageRepeat: repeat,
          imageCover: cover
        }),
        style: {
          width: '100%'
        },
        ref: function ref(node) {
          return _this2.container = node;
        }
      }, repeat ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "imageElement",
        style: {
          width: '100%',
          height: cover ? this.state.coverHeight : this.state.height,
          backgroundImage: "url('".concat(url.id ? downloadUrl(url.id) : url.body, "')"),
          backgroundSize: cover ? 'cover' : 'contain',
          backgroundRepeatX: repeat ? 'repeat' : 'no-repeat'
        }
      }) : /*#__PURE__*/_react["default"].createElement("img", {
        src: url.id ? downloadUrl(url.id) : url.body,
        style: {
          width: '100%',
          height: cover ? this.state.coverHeight : this.state.height
        }
      })) : null;
    }
  }]);

  return ImageComponent;
}(_react.Component);

exports.ImageComponent = ImageComponent;

var _default = (0, _withElementWrapper.withElementWrapper)(ImageComponent);

exports["default"] = _default;