"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _editor = require("../../utils/editor");

var _LinkInput = _interopRequireDefault(require("./LinkInput"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "toolbar": "editorToolbar__toolbar___r4vlg",
  "showToolbar": "editorToolbar__showToolbar___2Ygda",
  "toolbarItems": "editorToolbar__toolbarItems___2zvDc",
  "toolbarItem": "editorToolbar__toolbarItem___1D-K3",
  "toolbarItemsArrow": "editorToolbar__toolbarItemsArrow___2PwFu",
  "active": "editorToolbar__active___24dHq",
  "bold": "editorToolbar__bold___1I-VY",
  "italic": "editorToolbar__italic___1cQ9v",
  "underline": "editorToolbar__underline___xoLQR",
  "toolbarLinkContainer": "editorToolbar__toolbarLinkContainer___14xpk"
};
var INLINE_STYLES = [{
  label: 'B',
  style: 'BOLD',
  inline: true
}, {
  label: 'I',
  style: 'ITALIC',
  inline: true
}, {
  label: 'U',
  style: 'UNDERLINE',
  inline: true
}];
var BLOCK_STYLES = [{
  label: 'H1',
  style: 'header-one'
}, {
  label: 'H2',
  style: 'header-two'
}, {
  label: 'H3',
  style: 'header-three'
}, {
  label: /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-list-ul"
  }),
  style: 'unordered-list-item'
}, {
  label: /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-list-ol"
  }),
  style: 'ordered-list-item'
}, {
  label: /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-align-left"
  }),
  style: 'left'
}, {
  label: /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-align-right"
  }),
  style: 'right'
}, {
  label: /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-align-center"
  }),
  style: 'center'
}];

var InlineToolbar = /*#__PURE__*/function (_Component) {
  _inherits(InlineToolbar, _Component);

  var _super = _createSuper(InlineToolbar);

  function InlineToolbar() {
    var _this;

    _classCallCheck(this, InlineToolbar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onMouseDown", function (e, type) {
      e.preventDefault();

      _this.props.onToggle(type.style, type.inline);
    });

    _defineProperty(_assertThisInitialized(_this), "openLinkEditor", function (e) {
      e.preventDefault();

      _this.props.toggleLinkToolbar(true);
    });

    _defineProperty(_assertThisInitialized(_this), "getPositionData", function () {
      var selectionRange = _this.props.selectionRange;

      if (selectionRange) {
        return (0, _editor.getSelectionCoords)(_this.toolbar, selectionRange);
      }

      return {};
    });

    return _this;
  }

  _createClass(InlineToolbar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          editorState = _this$props.editorState,
          show = _this$props.show,
          _short = _this$props["short"],
          linkToolbar = _this$props.linkToolbar;
      var currentStyle = editorState.getCurrentInlineStyle();
      var positionData = this.getPositionData();
      var LIST = _short ? INLINE_STYLES : [].concat(INLINE_STYLES, BLOCK_STYLES);
      var blockStyle = editorState.getCurrentContent().getBlockForKey(editorState.getSelection().getStartKey()).getType();
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(node) {
          return _this2.toolbar = node;
        },
        className: (0, _classnames["default"])(styles.toolbar, 'toolbar', _defineProperty({}, styles.showToolbar, show)),
        style: positionData.coords
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.toolbarItems, 'toolbar-items')
      }, linkToolbar ? /*#__PURE__*/_react["default"].createElement(_LinkInput["default"], this.props) : /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, LIST.map(function (type) {
        var _cx2;

        return /*#__PURE__*/_react["default"].createElement("li", {
          key: type.style,
          className: (0, _classnames["default"])(styles.toolbarItem, 'toolbar-item', (_cx2 = {}, _defineProperty(_cx2, styles[type.style.toLowerCase()], true), _defineProperty(_cx2, styles.active, currentStyle.has(type.style) || type.style === blockStyle), _cx2)),
          onMouseDown: function onMouseDown(e) {
            return _this2.onMouseDown(e, type);
          }
        }, type.label);
      }), /*#__PURE__*/_react["default"].createElement("li", {
        className: (0, _classnames["default"])(styles.toolbarItem, 'toolbar-item', {
          active: !!(0, _editor.findEntityInSelection)(editorState, 'LINK')
        }),
        onMouseDown: this.openLinkEditor
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fa fa-link"
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.toolbarItemsArrow, 'toolbar-items-arraow'),
        style: {
          left: positionData.arrowPosition
        }
      })));
    }
  }]);

  return InlineToolbar;
}(_react.Component);

exports["default"] = InlineToolbar;

_defineProperty(InlineToolbar, "propTypes", {
  editorState: _propTypes["default"].object,
  selectionRange: _propTypes["default"].object,
  onToggle: _propTypes["default"].func,
  show: _propTypes["default"].bool,
  "short": _propTypes["default"].bool
});