"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.PdfComponent = void 0;

require("antd/lib/modal/style");

var _modal = _interopRequireDefault(require("antd/lib/modal"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/spin/style");

var _spin = _interopRequireDefault(require("antd/lib/spin"));

var _react = _interopRequireWildcard(require("react"));

var _reactPdf = require("react-pdf");

var _classnames = _interopRequireDefault(require("classnames"));

var _ramda = require("ramda");

var _icons = require("@ant-design/icons");

var _withElementWrapper = require("../../hocs/withElementWrapper");

var _withFileUrlContext = _interopRequireDefault(require("../../hocs/withFileUrlContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "pdfFooter": "pdf__pdfFooter___1Q-cn",
  "pdfPageButtons": "pdf__pdfPageButtons___1VVGa",
  "pdf": "pdf__pdf___3UETx",
  "pdfSpin": "pdf__pdfSpin___3XpG2",
  "pdfFullView": "pdf__pdfFullView___1m62k"
};
_reactPdf.pdfjs.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/".concat(_reactPdf.pdfjs.version, "/pdf.worker.js");

var Spinner = function Spinner() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(styles.pdfSpin, 'pdf-spin')
  }, /*#__PURE__*/_react["default"].createElement(_spin["default"], null));
};

var PdfField = /*#__PURE__*/function (_Component) {
  _inherits(PdfField, _Component);

  var _super = _createSuper(PdfField);

  function PdfField() {
    var _this;

    _classCallCheck(this, PdfField);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      numPages: null,
      pageNumber: 1,
      fullScreen: false,
      loaded: false
    });

    _defineProperty(_assertThisInitialized(_this), "onLoadSuccess", function (_ref) {
      var numPages = _ref.numPages;
      return _this.setState({
        numPages: numPages,
        pageNumber: 1,
        loaded: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "back", function () {
      return _this.setState(function (prev) {
        return {
          pageNumber: prev.pageNumber - 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "next", function () {
      return _this.setState(function (prev) {
        return {
          pageNumber: prev.pageNumber + 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getWidth", function () {
      return _this.props.width || (_this.pageRef ? _this.pageRef.ref.clientWidth : (0, _ramda.pathOr)(450, ['clientWidth'], _this.container));
    });

    _defineProperty(_assertThisInitialized(_this), "openFullPdf", function () {
      _this.setState({
        fullScreen: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeFullPdf", function () {
      _this.setState({
        fullScreen: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getPages", function () {
      var _this$state = _this.state,
          pageNumber = _this$state.pageNumber,
          numPages = _this$state.numPages;
      var pages = (0, _ramda.range)(pageNumber - 2, pageNumber + 3);
      return _this.props.allPages ? (0, _ramda.range)(1, numPages + 1) : (0, _ramda.filter)(function (num) {
        return num > 0 && num < numPages + 1;
      }, pages);
    });

    _defineProperty(_assertThisInitialized(_this), "renderPdf", function () {
      var _this$props = _this.props,
          file = _this$props.file,
          downloadUrl = _this$props.downloadUrl,
          allPages = _this$props.allPages;
      var fileUrl = file.id ? downloadUrl(file.id) : file.body;
      var _this$state2 = _this.state,
          pageNumber = _this$state2.pageNumber,
          numPages = _this$state2.numPages,
          loaded = _this$state2.loaded;

      var pages = _this.getPages();

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.pdf, 'pdf-component'),
        ref: function ref(node) {
          return _this.container = node;
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.pdfPageButtons, 'pdf-page-buttons')
      }, /*#__PURE__*/_react["default"].createElement(_button["default"].Group, null, !allPages && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        icon: /*#__PURE__*/_react["default"].createElement(_icons.LeftOutlined, null),
        onClick: _this.back,
        disabled: pageNumber < 2
      }), /*#__PURE__*/_react["default"].createElement(_button["default"], {
        icon: /*#__PURE__*/_react["default"].createElement(_icons.RightOutlined, null),
        onClick: _this.next,
        disabled: pageNumber >= numPages
      })), /*#__PURE__*/_react["default"].createElement(_button["default"], {
        icon: /*#__PURE__*/_react["default"].createElement(_icons.FullscreenOutlined, null),
        onClick: _this.openFullPdf
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          minHeight: (0, _ramda.pathOr)(0, ['ref', 'clientHeight'], _this.pageRef)
        }
      }, /*#__PURE__*/_react["default"].createElement(_reactPdf.Document, {
        ref: function ref(node) {
          return _this.pdf = node;
        },
        file: fileUrl,
        onLoadSuccess: _this.onLoadSuccess,
        loading: /*#__PURE__*/_react["default"].createElement(Spinner, null)
      }, pages.map(function (p) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "page-".concat(p),
          style: {
            display: p === pageNumber || allPages ? 'block' : 'none'
          }
        }, /*#__PURE__*/_react["default"].createElement(_reactPdf.Page, {
          ref: p === pageNumber ? function (node) {
            return _this.pageRef = node;
          } : null,
          pageNumber: p,
          width: _this.getWidth(),
          loading: /*#__PURE__*/_react["default"].createElement(Spinner, null)
        }));
      })), /*#__PURE__*/_react["default"].createElement(_modal["default"], {
        className: (0, _classnames["default"])(styles.pdfFullView, 'pdf-fullview'),
        visible: _this.state.fullScreen,
        closable: false,
        footer: /*#__PURE__*/_react["default"].createElement(_button["default"], {
          onClick: _this.closeFullPdf
        }, "\u0417\u0430\u043A\u0440\u044B\u0442\u044C"),
        width: "100%",
        destroyOnClose: true
      }, /*#__PURE__*/_react["default"].createElement("iframe", {
        height: "100%",
        width: "100%",
        scrolling: "no",
        frameBorder: "0",
        src: fileUrl
      }))), !allPages && loaded && /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.pdfFooter, 'pdf-footer')
      }, pageNumber, " / ", numPages));
    });

    return _this;
  }

  _createClass(PdfField, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prev) {
      if (this.props.file && !prev.file) {
        this.setState({
          loaded: false
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          file = _this$props2.file,
          label = _this$props2.label;
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        dangerouslySetInnerHTML: {
          __html: label
        }
      }), file ? this.renderPdf() : null);
    }
  }]);

  return PdfField;
}(_react.Component);

var PdfComponent = (0, _withFileUrlContext["default"])(PdfField);
exports.PdfComponent = PdfComponent;

var _default = (0, _withElementWrapper.withElementWrapper)(PdfComponent);

exports["default"] = _default;