"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioButtonsField = exports["default"] = void 0;

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/radio/style");

var _radio = _interopRequireDefault(require("antd/lib/radio"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uniqid = _interopRequireDefault(require("uniqid"));

var _ramda = require("ramda");

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _icons = require("@ant-design/icons");

var _withElementWrapper = require("../../hocs/withElementWrapper");

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

var _methods = require("../../utils/methods");

var _Editor = _interopRequireDefault(require("./Editor"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "optionItem": "options__optionItem___3iJsc",
  "optionRemoveBtn": "options__optionRemoveBtn___1nlIt",
  "optionReorder": "options__optionReorder___1eSk7",
  "optionAddBtn": "options__optionAddBtn___3eI-a",
  "optionLabel": "options__optionLabel___1yWrm",
  "correctAnswers": "options__correctAnswers___18tyV",
  "image": "options__image___3zj7j",
  "contentWithImage": "options__contentWithImage___126j8",
  "inlineOptions": "options__inlineOptions___1A8eP"
};

var RadioButtons = /*#__PURE__*/function (_Component) {
  _inherits(RadioButtons, _Component);

  var _super = _createSuper(RadioButtons);

  function RadioButtons() {
    var _this;

    _classCallCheck(this, RadioButtons);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          isEditor = _this$props.isEditor;
      var value = e.target.value;
      isEditor ? onChange('correct', value) : onChange(value);
    });

    _defineProperty(_assertThisInitialized(_this), "removeItem", function (index) {
      var _this$props2 = _this.props,
          options = _this$props2.options,
          onChange = _this$props2.onChange;
      onChange('options', (0, _ramda.remove)(index, 1, options));
    });

    _defineProperty(_assertThisInitialized(_this), "addItem", function () {
      var _this$props3 = _this.props,
          options = _this$props3.options,
          onChange = _this$props3.onChange,
          placeholder = _this$props3.placeholder;
      var option = {
        label: "".concat(placeholder, " ").concat(options.length),
        id: (0, _uniqid["default"])('radio_option_')
      };
      onChange('options', (0, _ramda.append)(option, options));
    });

    _defineProperty(_assertThisInitialized(_this), "renderRadio", function (option, index) {
      var _this$props4 = _this.props,
          isEditor = _this$props4.isEditor,
          disabled = _this$props4.disabled,
          correct = _this$props4.correct,
          allowCorrect = _this$props4.allowCorrect,
          value = _this$props4.input.value,
          options = _this$props4.options,
          downloadUrl = _this$props4.downloadUrl;
      var selected = value === option.id;
      var isCorrect = option.id === correct;
      var hasImages = (0, _ramda.any)(function (o) {
        return o.image;
      }, options);
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Draggable, {
        key: option.id,
        draggableId: option.id,
        index: index,
        isDragDisabled: !isEditor
      }, function (provided) {
        return /*#__PURE__*/_react["default"].createElement("div", _extends({
          ref: provided.innerRef
        }, provided.draggableProps, {
          style: provided.draggableProps.style
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.optionItem, 'option-item', {
            'option-item-correct': allowCorrect && isCorrect
          })
        }, isEditor && /*#__PURE__*/_react["default"].createElement("div", _extends({
          className: (0, _classnames["default"])(styles.optionReorder, 'option-reorder')
        }, provided.dragHandleProps), /*#__PURE__*/_react["default"].createElement("i", {
          className: "fa fa-reorder"
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])(_defineProperty({}, styles.contentWithImage, hasImages))
        }, option.image && /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.image, 'option-item-image'),
          style: {
            backgroundImage: "url('".concat(option.image.id ? downloadUrl(option.image.id) : option.image.data, "')")
          }
        }), /*#__PURE__*/_react["default"].createElement(_radio["default"], {
          value: option.id,
          className: disabled ? (0, _classnames["default"])({
            'correct': correct ? selected && isCorrect : selected,
            'incorrect': correct ? selected && !isCorrect : false
          }) : null
        }, !isEditor && /*#__PURE__*/_react["default"].createElement("span", {
          className: styles.optionLabel,
          dangerouslySetInnerHTML: {
            __html: option.label
          }
        })), isEditor && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
          className: styles.optionRemoveBtn,
          ghost: true,
          icon: /*#__PURE__*/_react["default"].createElement(_icons.DeleteOutlined, null),
          size: "small",
          danger: true,
          shape: "circle",
          onClick: function onClick() {
            return _this.removeItem(index);
          }
        }), /*#__PURE__*/_react["default"].createElement(_Editor["default"], _extends({}, _this.props, {
          path: "options.".concat(index, ".label"),
          "short": true
        }))))));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getShuffleOptions", (0, _ramda.memoizeWith)(_ramda.identity, function (options) {
      return (0, _methods.shuffle)(options);
    }));

    return _this;
  }

  _createClass(RadioButtons, [{
    key: "renderRadioButtons",
    value: function renderRadioButtons() {
      var _this$props5 = this.props,
          options = _this$props5.options,
          allowShuffle = _this$props5.allowShuffle,
          isEditor = _this$props5.isEditor;
      var items = allowShuffle && !isEditor ? this.getShuffleOptions(options) : options;
      return items.map(this.renderRadio);
    }
  }, {
    key: "render",
    value: function render() {
      var _cx2,
          _this2 = this;

      var _this$props6 = this.props,
          value = _this$props6.input.value,
          disabled = _this$props6.disabled,
          isEditor = _this$props6.isEditor,
          correct = _this$props6.correct,
          options = _this$props6.options,
          id = _this$props6.id,
          inline = _this$props6.inline;
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_radio["default"].Group, {
        className: (0, _classnames["default"])((_cx2 = {}, _defineProperty(_cx2, styles.inlineOptions, inline), _defineProperty(_cx2, "elementEditor", isEditor), _cx2)),
        onChange: this.onChange,
        value: isEditor ? correct : value,
        disabled: disabled
      }, /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: id,
        type: "field_".concat(id)
      }, function (provided) {
        return /*#__PURE__*/_react["default"].createElement("div", _extends({}, provided.droppableProps, {
          ref: provided.innerRef
        }), _this2.renderRadioButtons(), provided.placeholder);
      })), !!(disabled && correct && correct !== value) && /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.correctAnswers, 'correct-answers')
      }, /*#__PURE__*/_react["default"].createElement("b", null, "\u041F\u0440\u0430\u0432\u0438\u043B\u044C\u043D\u044B\u0439 \u043E\u0442\u0432\u0435\u0442: "), /*#__PURE__*/_react["default"].createElement("span", {
        dangerouslySetInnerHTML: {
          __html: (0, _ramda.path)(['label'], (0, _ramda.find)((0, _ramda.propEq)('id', correct), options))
        }
      })));
    }
  }]);

  return RadioButtons;
}(_react.Component);

_defineProperty(RadioButtons, "propTypes", {
  options: _propTypes["default"].array,
  input: _propTypes["default"].object,
  isEditor: _propTypes["default"].bool,
  onChange: _propTypes["default"].func
});

_defineProperty(RadioButtons, "defaultProps", {
  input: {},
  options: []
});

var _default = (0, _withElementWrapper.withElementWrapper)(RadioButtons);

exports["default"] = _default;
var RadioButtonsField = (0, _withFieldWrapper["default"])(RadioButtons);
exports.RadioButtonsField = RadioButtonsField;