"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Video = void 0;

require("antd/lib/input/style");

var _input = _interopRequireDefault(require("antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactPlayer = _interopRequireDefault(require("react-player"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withElementWrapper = require("../../hocs/withElementWrapper");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "video": "video__video___2vGQt",
  "videoWrapper": "video__videoWrapper___1Sou1",
  "dragging-over": "video__dragging-over___1fN0t"
};

var VideoPlayer = /*#__PURE__*/function (_Component) {
  _inherits(VideoPlayer, _Component);

  var _super = _createSuper(VideoPlayer);

  function VideoPlayer() {
    var _this;

    _classCallCheck(this, VideoPlayer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      minWidth: 0
    });

    return _this;
  }

  _createClass(VideoPlayer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var minWidth = this.container.clientWidth;
      this.setState({
        minWidth: minWidth,
        minHeight: 100 * minWidth / this.props.width * this.props.height / 100
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          isDraggingOver = _this$props.isDraggingOver,
          width = _this$props.width,
          height = _this$props.height,
          src = _this$props.src;
      var useMinSizes = width > this.state.minWidth;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])({
          'dragging-over': isDraggingOver
        }),
        style: {
          marginBottom: 15
        },
        ref: function ref(node) {
          return _this2.container = node;
        }
      }, /*#__PURE__*/_react["default"].createElement(_reactPlayer["default"], {
        url: src,
        width: useMinSizes ? this.state.minWidth : width,
        height: useMinSizes ? this.state.minHeight : height,
        controls: true
      }));
    }
  }]);

  return VideoPlayer;
}(_react.Component);

var Video = /*#__PURE__*/function (_Component2) {
  _inherits(Video, _Component2);

  var _super2 = _createSuper(Video);

  function Video() {
    var _this3;

    _classCallCheck(this, Video);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this3), "onChange", function (e) {
      _this3.props.onChange('src', e.target.value);
    });

    return _this3;
  }

  _createClass(Video, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          src = _this$props2.src,
          isEditor = _this$props2.isEditor,
          isDraggingOver = _this$props2.isDraggingOver,
          width = _this$props2.width,
          height = _this$props2.height;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.video, 'video')
      }, isEditor && /*#__PURE__*/_react["default"].createElement(_input["default"], {
        value: src,
        onChange: this.onChange,
        placeholder: "\u0412\u0441\u0442\u0430\u0432\u044C\u0442\u0435 \u0441\u0441\u044B\u043B\u043A\u0443 \u043D\u0430 \u0432\u0438\u0434\u0435\u043E \u0441 youtube"
      }), src ? /*#__PURE__*/_react["default"].createElement(VideoPlayer, {
        isDraggingOver: isDraggingOver,
        width: width,
        height: height,
        src: src
      }) : null);
    }
  }]);

  return Video;
}(_react.Component);

exports.Video = Video;

_defineProperty(Video, "propTypes", {
  src: _propTypes["default"].string,
  isEditor: _propTypes["default"].bool,
  isDraggingOver: _propTypes["default"].bool
});

_defineProperty(Video, "defaultProps", {
  src: ''
});

var _default = (0, _withElementWrapper.withElementWrapper)(Video);

exports["default"] = _default;