"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _uniqid = _interopRequireDefault(require("uniqid"));

var _range = _interopRequireDefault(require("ramda/src/range"));

var _length = _interopRequireDefault(require("ramda/src/length"));

var _symmetricDifference = _interopRequireDefault(require("ramda/src/symmetricDifference"));

var _Checkboxes = _interopRequireWildcard(require("../components/formElements/Checkboxes"));

var _RadioButtons = _interopRequireWildcard(require("../components/formElements/RadioButtons"));

var _Range = _interopRequireWildcard(require("../components/formElements/Range"));

var _Editor = _interopRequireDefault(require("../components/formElements/Editor"));

var _EditorComponent = _interopRequireDefault(require("../components/formElements/EditorComponent"));

var _Video = _interopRequireWildcard(require("../components/formElements/Video"));

var _File = _interopRequireWildcard(require("../components/formElements/File"));

var _DownloadFile = _interopRequireWildcard(require("../components/formElements/DownloadFile"));

var _Pdf = _interopRequireWildcard(require("../components/formElements/Pdf"));

var _Image = _interopRequireWildcard(require("../components/formElements/Image"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var arrayIncorrect = function arrayIncorrect(value, correct) {
  return (0, _length["default"])((0, _symmetricDifference["default"])(value || [], correct || [])) ? 'Неправильный ответ' : undefined;
};

var renderInfo = function renderInfo() {
  var prop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'label';
  return function (props) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      dangerouslySetInnerHTML: {
        __html: props[prop]
      }
    });
  };
};

var COMPONENTS_DEFAULTS = function COMPONENTS_DEFAULTS(placeholder) {
  return [{
    type: 'Editor',
    name: 'Текст',
    icon: 'font',
    renderInfo: renderInfo('content'),
    component: _Editor["default"],
    formComponent: _EditorComponent["default"],
    props: {
      content: '<p><br></p>'
    },
    staticContent: true,
    hidePreview: true,
    fields: [{
      type: 'editor',
      prop: 'content'
    }]
  }, {
    type: 'Checkboxes',
    name: 'Множественный выбор',
    icon: 'check-square-o',
    renderInfo: renderInfo(),
    component: _Checkboxes["default"],
    formComponent: _Checkboxes.CheckboxesField,
    fieldType: 'checkbox',
    props: {
      label: 'Множественный выбор',
      options: (0, _range["default"])(0, 3).map(function (i) {
        return {
          label: "".concat(placeholder || 'выбор', " ").concat(i),
          id: (0, _uniqid["default"])('checkboxes_option_')
        };
      })
    },
    ableCorrect: true,
    correctValidator: arrayIncorrect,
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }, {
      type: 'multiple',
      label: 'Ответы',
      prop: 'options',
      fieldArray: true
    }, {
      type: 'input',
      label: 'Вес вопроса',
      prop: 'questionWeight',
      props: {
        number: true
      }
    }, {
      type: 'switch',
      label: 'Обязательное поле',
      prop: 'required'
    }, {
      type: 'switch',
      label: 'Правильный ответ',
      prop: 'allowCorrect'
    }, {
      type: 'switch',
      label: 'Выводить варианты в случайном порядке',
      prop: 'allowShuffle'
    }, {
      type: 'switch',
      label: 'Отображать варианты по горизонтали',
      prop: 'inline'
    }]
  }, {
    type: 'Radio',
    name: 'Выбор',
    icon: 'dot-circle-o',
    renderInfo: renderInfo(),
    component: _RadioButtons["default"],
    formComponent: _RadioButtons.RadioButtonsField,
    fieldType: 'radio',
    props: {
      label: 'Выбор',
      options: (0, _range["default"])(0, 3).map(function (i) {
        return {
          label: "".concat(placeholder || 'выбор', " ").concat(i),
          id: (0, _uniqid["default"])('radiobuttons_option_')
        };
      })
    },
    ableCorrect: true,
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }, {
      type: 'multiple',
      label: 'Ответы',
      prop: 'options',
      fieldArray: true
    }, {
      type: 'input',
      label: 'Вес вопроса',
      prop: 'questionWeight',
      props: {
        number: true
      }
    }, {
      type: 'switch',
      label: 'Обязательное поле',
      prop: 'required'
    }, {
      type: 'switch',
      label: 'Правильный ответ',
      prop: 'allowCorrect'
    }, {
      type: 'switch',
      label: 'Выводить варианты в случайном порядке',
      prop: 'allowShuffle'
    }, {
      type: 'switch',
      label: 'Отображать варианты по горизонтали',
      prop: 'inline'
    }]
  }, {
    type: 'Range',
    name: 'Слайдер',
    icon: 'sliders',
    renderInfo: renderInfo(),
    component: _Range["default"],
    formComponent: _Range.RangeField,
    fieldType: 'range',
    props: {
      label: 'Слайдер',
      step: 1,
      defaultValue: 3,
      minValue: 1,
      maxValue: 5,
      minLabel: 'Минимум',
      maxLabel: 'Максимум'
    },
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }, {
      type: 'input',
      label: 'Значение по-умолчанию',
      prop: 'defaultValue',
      props: {
        number: true
      }
    }, {
      type: 'input',
      label: 'Шаг',
      prop: 'step',
      props: {
        number: true,
        min: 1
      }
    }, {
      type: 'input',
      label: 'Минимальное значение',
      prop: 'minValue',
      props: {
        number: true
      }
    }, {
      type: 'input',
      label: 'Название минимального значения',
      prop: 'minLabel'
    }, {
      type: 'input',
      label: 'Максимальное значение',
      prop: 'maxValue',
      props: {
        number: true
      }
    }, {
      type: 'input',
      label: 'Название максимального значения',
      prop: 'maxLabel'
    }, {
      type: 'switch',
      label: 'Обязательное поле',
      prop: 'required'
    }, {
      type: 'input',
      label: 'Вес вопроса',
      prop: 'questionWeight',
      props: {
        number: true
      }
    }]
  }, {
    type: 'Video',
    name: 'Видео',
    icon: 'video-camera',
    component: _Video["default"],
    formComponent: _Video.Video,
    staticContent: true,
    props: {
      width: 560,
      height: 350
    },
    fields: [{
      type: 'input',
      label: 'Ссылка на видео',
      prop: 'src'
    }, {
      type: 'input',
      label: 'Высота',
      prop: 'height',
      props: {
        number: true
      }
    }, {
      type: 'input',
      label: 'Ширина',
      prop: 'width',
      props: {
        number: true
      }
    }]
  }, {
    type: 'File',
    name: 'Файл',
    icon: 'file-o',
    renderInfo: renderInfo(),
    component: _File["default"],
    formComponent: _File.FileField,
    props: {
      label: 'Файл'
    },
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }]
  }, {
    type: 'DownloadFile',
    name: 'Скачивание файла',
    icon: 'download',
    component: _DownloadFile["default"],
    formComponent: _DownloadFile.DownloadFile,
    staticContent: true,
    props: {
      label: 'Файл'
    },
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }, {
      type: 'uploader',
      label: 'Файл',
      prop: 'file'
    }]
  }, {
    type: 'Pdf',
    name: 'PDF-презентация',
    icon: 'file-pdf-o',
    component: _Pdf["default"],
    formComponent: _Pdf.PdfComponent,
    staticContent: true,
    props: {
      label: 'PDF-презентация'
    },
    fields: [{
      type: 'editor',
      label: 'Название поля',
      prop: 'label',
      props: {
        "short": true
      }
    }, {
      type: 'uploader',
      label: 'Файл',
      prop: 'file',
      props: {
        accept: '.pdf'
      }
    }, {
      type: 'input',
      label: 'Ширина',
      prop: 'width',
      props: {
        number: true
      }
    }, {
      type: 'switch',
      label: 'Выводить все страницы',
      prop: 'allPages'
    }]
  }, {
    type: 'Image',
    name: 'Изображение',
    icon: 'picture-o',
    component: _Image["default"],
    formComponent: _Image.ImageComponent,
    staticContent: true,
    fields: [{
      type: 'uploader',
      label: 'Изображение',
      prop: 'url',
      props: {
        withoutUrl: true,
        accept: 'image/*'
      }
    }, {
      type: 'switch',
      label: 'Растянуть на всю ширину',
      prop: 'cover'
    }, {
      type: 'switch',
      label: 'Повторять по горизонтали',
      prop: 'repeat'
    }]
  }];
};

var _default = COMPONENTS_DEFAULTS;
exports["default"] = _default;