"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ramda = require("ramda");

var _uniqid = _interopRequireDefault(require("uniqid"));

var _dnd = require("../utils/dnd");

var _EditModalContext = _interopRequireDefault(require("../contexts/EditModalContext"));

var _componentsDefaults = _interopRequireDefault(require("../constants/componentsDefaults"));

var _ComponentsContext = _interopRequireDefault(require("../contexts/ComponentsContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(WrappedComponent) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_Component) {
    _inherits(_class, _Component);

    var _super = _createSuper(_class);

    function _class(_props) {
      var _this;

      _classCallCheck(this, _class);

      _this = _super.call(this, _props);

      _defineProperty(_assertThisInitialized(_this), "reorder", function (startIndex, endIndex) {
        _this.setState(function (prev) {
          return {
            items: (0, _dnd.reorder)(prev.items, startIndex, endIndex)
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "add", function (type, index) {
        var id = (0, _uniqid["default"])();
        var defaultProps = (0, _ramda.pathOr)({}, ['props'], (0, _ramda.find)((0, _ramda.propEq)('type', type), _this.getComponents()));

        _this.setState(function (prev) {
          return {
            items: (0, _ramda.insert)((0, _ramda.isNil)(index) ? prev.items.length : index, id, prev.items),
            elements: (0, _ramda.assocPath)([id], _objectSpread({
              type: type
            }, defaultProps), prev.elements),
            openedEditModal: id
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "edit", function (id, prop, content) {
        _this.setState(function (prev) {
          return {
            elements: (0, _ramda.assocPath)([id].concat(_toConsumableArray(prop.split('.').map(function (i) {
              return (0, _ramda.identical)(NaN, +i) ? i : +i;
            }))), content, prev.elements)
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "editAllItem", function (id, props) {
        _this.setState(function (prev) {
          return {
            elements: (0, _ramda.assocPath)([id], _objectSpread(_objectSpread({}, prev.elements[id]), props), prev.elements)
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "remove", function (id) {
        _this.setState(function (prev) {
          return {
            items: (0, _ramda.without)([id], prev.items),
            elements: (0, _ramda.dissoc)(id, prev.elements)
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "setOpenedEditModal", function (openedEditModal) {
        return _this.setState({
          openedEditModal: openedEditModal
        });
      });

      _defineProperty(_assertThisInitialized(_this), "getComponents", function () {
        var _this$props = _this.props,
            placeholder = _this$props.placeholder,
            components = _this$props.components,
            getComponents = _this$props.getComponents;
        var items = (0, _ramda.concat)((0, _componentsDefaults["default"])(placeholder), components);
        return getComponents ? getComponents(items) : items;
      });

      _defineProperty(_assertThisInitialized(_this), "editCommon", function (common) {
        return _this.setState({
          common: common
        });
      });

      var _ref = _props.data || {},
          _ref$items = _ref.items,
          _items = _ref$items === void 0 ? [] : _ref$items,
          _ref$elements = _ref.elements,
          elements = _ref$elements === void 0 ? {} : _ref$elements,
          _ref$common = _ref.common,
          _common = _ref$common === void 0 ? {} : _ref$common;

      _this.state = {
        items: _items,
        elements: elements,
        common: _common
      };
      return _this;
    }

    _createClass(_class, [{
      key: "getSnapshotBeforeUpdate",
      value: function getSnapshotBeforeUpdate(prevProps, prevState) {
        return !(0, _ramda.equals)(prevState, this.state);
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState, snapshot) {
        if (snapshot) {
          var onChange = this.props.onChange;
          onChange && onChange(this.state.items.length ? this.state : null);
        }
      }
    }, {
      key: "render",
      value: function render() {
        var props = {
          items: this.state.items,
          elements: this.state.elements,
          commonSettings: this.state.common,
          reorderItems: this.reorder,
          editItem: this.edit,
          editAllItem: this.editAllItem,
          removeItem: this.remove,
          addItem: this.add,
          editCommonSettings: this.editCommon
        };
        return /*#__PURE__*/_react["default"].createElement(_EditModalContext["default"].Provider, {
          value: {
            opened: this.state.openedEditModal,
            setOpened: this.setOpenedEditModal
          }
        }, /*#__PURE__*/_react["default"].createElement(_ComponentsContext["default"].Provider, {
          value: this.getComponents()
        }, /*#__PURE__*/_react["default"].createElement(WrappedComponent, _extends({}, this.props, props))));
      }
    }]);

    return _class;
  }(_react.Component), _defineProperty(_class, "propTypes", {
    data: _propTypes["default"].object
  }), _defineProperty(_class, "defaultProps", {
    placeholder: 'вариант',
    components: []
  }), _temp;
};

exports["default"] = _default;